/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_PAR_FILIAL_GEP                                           */
/* Tabela : PAR_FILIAL_GEP                                                    */
/*                                                                            */
/* Criao:                                                                   */
/* 11/11/2008 - Diego Gonzaga                                                 */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_PAR_FILIAL_GEP
BEFORE INSERT OR UPDATE OR DELETE
ON PAR_FILIAL_GEP FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUPARFIGE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL ,0)        <> NVL(:NEW.CDFILIAL ,0))        OR
         (NVL(:OLD.DSDIRWEBFONT,0)     <> NVL(:NEW.DSDIRWEBFONT  ,0))   OR
         (NVL(:OLD.DSDIRWINFONT ,0)    <> NVL(:NEW.DSDIRWINFONT ,0))    OR
         (NVL(:OLD.CDNVPESQPROC ,0)    <> NVL(:NEW.CDNVPESQPROC ,0))    OR          
         (NVL(:OLD.CDSETORPROC ,0)     <> NVL(:NEW.CDSETORPROC ,0))     OR
         (NVL(:OLD.VRPESOALTCPX ,0)    <> NVL(:NEW.VRPESOALTCPX ,0))    OR
         (NVL(:OLD.CDCLIENTE ,0)       <> NVL(:NEW.CDCLIENTE ,0))       OR         
         (NVL(:OLD.NRSALASCHAT ,0)     <> NVL(:NEW.NRSALASCHAT ,0))     OR
         (NVL(:OLD.CDATIVCLIREVEND ,0) <> NVL(:NEW.CDATIVCLIREVEND ,0)) OR
         (NVL(:OLD.VRPERCOMINACMDO ,0) <> NVL(:NEW.VRPERCOMINACMDO ,0)) OR
         (NVL(:OLD.VRPERCOMIINTMDO ,0) <> NVL(:NEW.VRPERCOMIINTMDO ,0)) THEN
         :NEW.DTULTATUPARFIGE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('PAR_FILIAL_GEP', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE PAR_FILIAL_GEP MODIFY DTULTATUPARFIGE DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_PAR_FILIAL_GEP','5.05.019'); END;
/
