function Dfs51000_InutilizacaoNotaFiscalEletronica_Controller (ZhFilterPreferences, Dfs49000_TransmissaoNfe_Service, Dfs51000_InutilizacaoNotaFiscalEletronica_Service, ScreenService, templateManager, General, ZHPromise) {

    this.filtrar = function(args){
        var widget = args.owner;
        var filtroBforeApply = templateManager.container.getActiveWidget();
        var filtro;
          
        filtro = (filtroBforeApply.name == 'zhFilterPreferencesSelectConditions') ? filtroBforeApply.currentRow : widget.appliedFilter;
        this.montaConfig(args);
        
        //args.e.preventDefault();
    };
    
    this.transmissaoNFE = function(args){
        var widget = args.owner;
        this.setDefaultInutNFEFilter(widget).then(defaultFilter =>{
            ZhFilterPreferences.setOriginalFilter(widget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(widget, defaultFilter);
            widget.currentRow=Util.clone(defaultFilter);
            this.controlaCampoUnidade(widget);
        });
    };
    
    this.setDefaultInutNFEFilter = function(widget) {
        var promise = ZHPromise.defer();
        var defaultFilter = Util.clone(widget.currentRow);
        defaultFilter.CDFILIAL=undefined;
        defaultFilter.CDEMPRESA=undefined;
        defaultFilter.NMRAZSOCEMPR=undefined;
        defaultFilter.NMFILIAL=undefined;
        
        if(sessionStorage.length>0){
           defaultFilter.CDFILIAL = (sessionStorage.getItem('CDFILIAL'));
           sessionStorage.removeItem('CDFILIAL');
           defaultFilter.NMFILIAL = (sessionStorage.getItem('NMFILIAL'));
           sessionStorage.removeItem('NMFILIAL');
           defaultFilter.NMRAZSOCEMPR = (sessionStorage.getItem('NMRAZSOCEMPR'));
           sessionStorage.removeItem('NMRAZSOCEMPR');
           defaultFilter.CDEMPRESA = (sessionStorage.getItem('CDEMPRESA'));
           sessionStorage.removeItem('CDEMPRESA');
           defaultFilter.CDINSCMUNI = (sessionStorage.getItem('CDINSCMUNI'));
           sessionStorage.removeItem('CDINSCMUNI');
           defaultFilter.CDINSCESTA = (sessionStorage.getItem('CDINSCESTA'));
           sessionStorage.removeItem('CDINSCESTA');
           defaultFilter.NRINSJURIEST = (sessionStorage.getItem('NRINSJURIEST'));
           sessionStorage.removeItem('NRINSJURIEST');
           defaultFilter.IDENDEMISFIL = (sessionStorage.getItem('IDENDEMISFIL'));
           sessionStorage.removeItem('IDENDEMISFIL');
        }
        promise.resolve(defaultFilter);
        return promise;
    };
    
    /**
     * Seta Data Souce Stripe
     * @param widget
     */
    this.setStripeData = function(widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.NMFILIAL   = currentRow.CDFILIAL + ' - ' + currentRow.NMFILIAL;
        stripeWidget.currentRow.NMRAZSOCEMPR   = currentRow.CDEMPRESA + ' - ' + currentRow.NMRAZSOCEMPR;
        stripeWidget.currentRow.CDINSCESTA   = currentRow.CDINSCESTA;
        stripeWidget.currentRow.CDINSCMUNI   = currentRow.CDINSCMUNI;
    };

    this.recarregarCampo = function(nomeWidget,nomeCampo){
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.getField(nomeCampo).reload();
    };

    this.getValueCampo = function(nomeCampo){
        var widget = templateManager.container.getWidget('gridNotasFiscais');
        //widget.getField(nomeCampo).value();
        return widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : null;
    };

    this.controlaCampoUnidade = function(widget){
        var campoSerie = widget.getField('DSSERIE');
        var empresa = widget.getField('NMRAZSOCEMPR');
        if(widget.currentRow.NMFILIAL){
            campoSerie.readOnly = false;
            empresa.readOnly = false;
            empresa.dataSourceFilter[0].value=widget.currentRow.CDFILIAL;
        }else{
            campoSerie.readOnly = true;
            empresa.readOnly = true;
        }
        widget.getField('NMFILIAL').reload();
        empresa.reload();
        campoSerie.reload();
        widget.currentRow.CDSERIE = '';
        widget.currentRow.NMRAZSOCEMPR = '';
        widget.currentRow.DSSERIE = '';
        widget.currentRow.CDSERIENFE = '';
        this.setFiltroSerieNF(widget);
    };
    
    this.setFiltroSerieNF = function(widget){
        widget.getField('DSSERIE').dataSourceFilter.forEach(function(filtro){
            switch(filtro.name){
                case 'CDEMPRESA': filtro.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDINSCESTA': filtro.value = widget.currentRow.CDINSCESTA;
                    break;
                case 'CDINSCMUNI': filtro.value = widget.currentRow.CDINSCMUNI;
                    break;
            }
        });
    };

    this.inutilizarNf = function (widget){
        if(widget.getCheckedRows().length >0){
            var popup = templateManager.container.getWidget('widgetInutulizacao');
            if( this.validaInutilizacao(widget) ){
                popup.currentRow.JUSTIFICATIVA = null;
                ScreenService.openPopup(popup);
            }
        }else{
            ScreenService.showMessage('Faixa de numeração deve ser informada.');
        }
    };

    this.confirmarInutilizacao = function (args){
        var widget = args.owner.widget;
        var widgetNf = templateManager.container.getWidget('gridNotasFiscais');
        if(widget.isValid()){
            if(widget.currentRow.JUSTIFICATIVA.length >= 15){
                Dfs51000_InutilizacaoNotaFiscalEletronica_Service.aplicaJustificativa(widget.currentRow.JUSTIFICATIVA, widgetNf.getCheckedRows(),widgetNf.appliedFilter);
                Dfs51000_InutilizacaoNotaFiscalEletronica_Service.confirmarInutilizacao(widgetNf.getCheckedRows()).then(function(Success) {
                    ScreenService.closePopup(0);
                    widgetNf.reload();
                }.bind(this), function(callback){
                    if(callback.data){
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }else{
                ScreenService.showMessage('Justificativa deve conter no mínimo 15 caracteres.');
            }
        }
    };

    this.confirmarAgendamento = function (args){
        var widget = args.owner.widget;
        var widgetNf = templateManager.container.getWidget('gridNotasFiscais');
        if(widget.isValid()){
            ScreenService.confirmMessage('A consulta de numeração para inutilização pode demorar alguns minutos. Deseja continuar essa operação?', 'question', function (success) {
                Dfs51000_InutilizacaoNotaFiscalEletronica_Service.confirmarAgendamento(widget.currentRow)
                    .then(function(Success) {
                        ScreenService.closePopup(0);
                        widgetNf.reload();
                    }.bind(this), function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            });
        }
    };

    this.montaConfig = function(args){

        Dfs49000_TransmissaoNfe_Service.montaConfigTransmissao(args.owner.appliedFilter.FILTER_ROW).then((
            function(resp){
                var widgetNf = templateManager.container.getWidget('gridNotasFiscais');
                widgetNf.getAction('agendamento').isVisible = true;
            }).bind(this),
            function(error){
                // QUANDO OCORRER ALGUM PROBLEMA COM O CERTIFICADO NÃO PODE MOSTRAR OS DADOS
                var widgetNf = templateManager.container.getWidget('gridNotasFiscais');
                widgetNf.dataSource.data = null;
                var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
                if (error && error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage, "ERROR");
            }
        );
    };


    /*this.openFilter = function(widget){
        var filter = [{name: "CDFILIAL", "operator": "=", value: "FILIAL_LOGADA"}];
        General.callRestEngine("df#/crud/filial", "FilterData", filter).then((success) => {
            widget.currentRow.CDFILIAL      = success.dataset.filial[0].CDFILIAL;
            widget.currentRow.NMFILIAL      = success.dataset.filial[0].NMFILIAL;
            widget.currentRow.CDEMPRESA     = success.dataset.filial[0].CDEMPRESA;
            widget.currentRow.CDINSCESTA    = success.dataset.filial[0].CDINSCESTA;
            widget.currentRow.CDINSCMUNI    = success.dataset.filial[0].CDINSCMUNI;
            var filter = [{name: "CDEMPRESA", "operator": "=", value: widget.currentRow.CDEMPRESA}];
            this.controlaCampoUnidade(widget);
            widget.getField("DSSERIE").filterProperties.readOnly = false;
            General.callRestEngine("df#/crud/empresa_filial_filioper", "FilterData").then((success) => {
                widget.currentRow.NMRAZSOCEMPR = success.dataset.empresa[0].NMRAZSOCEMPR;
                var row = Util.clone(widget.currentRow);
                
                ZhFilterPreferences.setOriginalFilter(widget.id, row);
                ZhFilterPreferences.openFilterWidget(widget, row).then( () =>{
                    this.setFiltroSerieNF(templateManager.container.getActiveWidget());
                });
            },
            () => ZhFilterPreferences.openFilterWidget(widget));
           
        },
        () => ZhFilterPreferences.openFilterWidget(widget));
        
    };*/


    this.agendar = function (widget){
        var popup = templateManager.container.getWidget('widgetAgendamento');
        this.setarValoresAgendamento(popup);
        ScreenService.openPopup(popup);
    };

    this.setarValoresAgendamento = function(popup){
        let filtro = popup.getParent().appliedFilter;
        
        popup.currentRow.NMRAZSOCEMPR = filtro.FILTER_ROW.NMRAZSOCEMPR;
        popup.currentRow.CDEMPRESA    = filtro.FILTER_ROW.CDEMPRESA;
        popup.currentRow.NMFILIAL     = filtro.FILTER_ROW.NMFILIAL;
        popup.currentRow.CDFILIAL     = filtro.FILTER_ROW.CDFILIAL;
        popup.currentRow.CDINSCESTA   = filtro.FILTER_ROW.CDINSCESTA;
        popup.currentRow.CDINSCMUNI   = filtro.FILTER_ROW.CDINSCMUNI;
        popup.currentRow.CDSERIENFE   = filtro.FILTER_ROW.CDSERIENFE;
        popup.currentRow.NRINSJURIEST = filtro.FILTER_ROW.NRINSJURIEST;

        Dfs51000_InutilizacaoNotaFiscalEletronica_Service.getDataSourceConfigTransmissao()
            .then(function(config) {
                Dfs51000_InutilizacaoNotaFiscalEletronica_Service.buscaAgendamento(popup.currentRow, config)
                    .then(function(Success) {
                        popup.currentRow.DTHRULTIMACONSULTA =  Success.dataset.data.ultimaConsulta;
                        popup.currentRow.DTHRPROXIMACONSULTA =  Success.dataset.data.proximaConsulta;
                        popup.currentRow.IDSITUAGENDA =  Success.dataset.data.situacaoAgendamento;
                        popup.redraw();
                    }.bind(this),function(callback){
                        if(callback.data){
                            ScreenService.showMessage(callback.data.error);
                        }
                    }
                );
            }.bind(this), function(callback){
                if(callback.data){
                    ScreenService.showMessage(callback.data.error);
                }
            }
        );
    };


    // fazer a validação para não deixa inutilizar uma serie ja homologada
    this.validaInutilizacao = function(widget){
        var rows = widget.getCheckedRows();
        var rowsValidadas= [];
        var msg = [];
        rows.forEach(function(row) {
            if(row.IDSTATUS=='A'){
                row.__isSelected = false;
                var numeracao ="'"+row.INTERVALOINI+"'"+' - '+"'"+row.INTERVALOFIN+"'"+'<br/>';
                msg.push(numeracao);
            }else{
                rowsValidadas.push(row);
            }
        });
        widget.dataSource.updateCheckedRows();
        if(msg.length>0){
            var mensagem ='';
            msg.forEach(function(msg) {
                mensagem = mensagem +msg;
            });
            ScreenService.showMessage('A(s) seguinte(s) faixa(s) de numeração já foi(ram) inutilizada(s):'+'<br/>'+mensagem);
        }
        if(rowsValidadas.length==0){
           return false;
        }else{
            return true;
        }
    };

}

Configuration(function (ContextRegister) {
    ContextRegister.register("Dfs51000_InutilizacaoNotaFiscalEletronica_Controller", Dfs51000_InutilizacaoNotaFiscalEletronica_Controller);
});
